package uxtoweb.control;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Date;
import javax.faces.model.DataModel;
import javax.faces.model.ListDataModel;

import java.util.Collections;
import java.util.Comparator;
import uxtoweb.util.HbmUtil;
import org.hibernate.Query;
import org.hibernate.Session;

import com.ibm.jps.cdshop.User;
	
/**
 * WARNING!
 *
 * This class was generated automatically by the UXToWeb transformation. Do not 
 * attempt to modify it as any change will be permanently lost at the next 
 * execution of the transformation.
 */
public class UserManager {
	private static UserManager uniqueInstance = null;
	private User user = null; // Current 
    private List users = new ArrayList();
    private Map userMap = new HashMap();
    private DataModel userModel = new ListDataModel(); // Wrapper for users

    {
    	uniqueInstance = this;
 		// Read users from the database
	    List tempList = readUsers();
	    for (int i = 0; i < tempList.size(); i++) {
	    	User temp = (User) tempList.get(i);
	    	addUser(temp);
	    }
   		userModel.setWrappedData(users);
    }

	public static UserManager getInstance() {
		if (uniqueInstance == null) {
			uniqueInstance = new UserManager();
		}
		return uniqueInstance;
	}

	public User getUser() {
		if (user == null) {
			user = new User();
		}
		return user;
	}

	public void setUser (User user) {
		this.user = user;
	}
	
    public User getUserByUsername(String username) {
 		return (User) userMap.get(username);
    }

    private String assignUserUsername() {
        return new Long((new Date()).getTime()).toString();
    }
    public void addUser(User user) {
        users.add(user);
        userMap.put(user.getUsername(), user);
    }
	
    public DataModel getUsers(){
 		return userModel;
    }
	
    public User readUser(String username) {
		Session session = HbmUtil.getSessionFactory().openSession();
		session.beginTransaction();
		Query q = session.createQuery("from User where username='" + username + "'");
		List result = new ArrayList();
		if (q != null) result = q.list();
		session.getTransaction().commit();
		session.close();
		if (result.isEmpty())
			return null;
		else
			return (User) result.get(0);
     }
    
    public List readUsers() {
        Session session = HbmUtil.getSessionFactory().openSession();
        session.beginTransaction();

        Query q = session.createQuery("from User");
        List result = new ArrayList();
        if (q != null) result = q.list();

        session.getTransaction().commit();
        session.close();
        return result;
    }
    
    public void saveUser() {
    	// Retrieve the key. If it does not exist, assign one (if applicable)
    	String username = user.getUsername();
    	if (username == null) {
    		user.setUsername (assignUserUsername());
    	}
    	// Check if there is already an object with the same key
    	User temp = getUserByUsername(username);
    	if (temp == null) {
        	addUser(user);
	        Session session = HbmUtil.getSessionFactory().openSession();
	        session.beginTransaction();
	        session.save(user);
	        session.getTransaction().commit();
	        session.close();
	    } else {
	    	System.err.println(">>> UserManager.saveUser: Invalid save request for existing User object with key " + username.toString());
       	}
    }  
    
    public void updateUser() {
    	String username = user.getUsername();
    	if (username == null) {
	    	System.err.println(">>> UserManager.updateUser: Invalid update request for object with null key");
    	} else {
    		User temp = getUserByUsername(username);
    		if (temp != null) {
		        Session session = HbmUtil.getSessionFactory().openSession();
		        session.beginTransaction();
		        session.update(user);
		        session.getTransaction().commit();
		        session.close();
	    	} else {
	    		System.err.println(">>> UserManager.updateUser: Invalid update request for non-existent object with key " + username.toString());
	    	}
    	}
    }
	
    private transient final Comparator passwordAscendingComparator = new Comparator() {
        public int compare(Object object1, Object object2) {
            try {
                String property1 = ((User) object1).getPassword();
                String property2 = ((User) object2).getPassword();
                return property1.toLowerCase().compareTo(property2.toLowerCase());
            } catch (Exception e) {
                return 0;
            }
        }
    };
    	 
    public String sortByPassword() {
    	Collections.sort(users, passwordAscendingComparator);
 		this.userModel.setWrappedData(users);
        return "sort";
    }
	
    private transient final Comparator usernameAscendingComparator = new Comparator() {
        public int compare(Object object1, Object object2) {
            try {
                String property1 = ((User) object1).getUsername();
                String property2 = ((User) object2).getUsername();
                return property1.toLowerCase().compareTo(property2.toLowerCase());
            } catch (Exception e) {
                return 0;
            }
        }
    };
    	 
    public String sortByUsername() {
    	Collections.sort(users, usernameAscendingComparator);
 		this.userModel.setWrappedData(users);
        return "sort";
    }
	
    private transient final Comparator firstnameAscendingComparator = new Comparator() {
        public int compare(Object object1, Object object2) {
            try {
                String property1 = ((User) object1).getFirstname();
                String property2 = ((User) object2).getFirstname();
                return property1.toLowerCase().compareTo(property2.toLowerCase());
            } catch (Exception e) {
                return 0;
            }
        }
    };
    	 
    public String sortByFirstname() {
    	Collections.sort(users, firstnameAscendingComparator);
 		this.userModel.setWrappedData(users);
        return "sort";
    }
	
    private transient final Comparator lastnameAscendingComparator = new Comparator() {
        public int compare(Object object1, Object object2) {
            try {
                String property1 = ((User) object1).getLastname();
                String property2 = ((User) object2).getLastname();
                return property1.toLowerCase().compareTo(property2.toLowerCase());
            } catch (Exception e) {
                return 0;
            }
        }
    };
    	 
    public String sortByLastname() {
    	Collections.sort(users, lastnameAscendingComparator);
 		this.userModel.setWrappedData(users);
        return "sort";
    }
	
    private transient final Comparator fullNameAscendingComparator = new Comparator() {
        public int compare(Object object1, Object object2) {
            try {
                String property1 = ((User) object1).getFullName();
                String property2 = ((User) object2).getFullName();
                return property1.toLowerCase().compareTo(property2.toLowerCase());
            } catch (Exception e) {
                return 0;
            }
        }
    };
    	 
    public String sortByFullName() {
    	Collections.sort(users, fullNameAscendingComparator);
 		this.userModel.setWrappedData(users);
        return "sort";
    }
}    