package com.ibm.jps.uxtoweb.frontend.custom;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.uml2.uml.Class;
import org.eclipse.uml2.uml.Operation;

import com.ibm.xtools.transform.authoring.ExtractorExtension;

public class Operation2FindOpExtractor implements ExtractorExtension {

	@SuppressWarnings("unchecked")
	public Collection execute(EObject arg0) {
		ModelUtil.log("Operation2FindOpExtractor", arg0);
		Class inCl = (Class) arg0;
		Collection<Operation> c = new BasicEList();
		// Add to the collection all <<useraction>> operations (from <<screen>> classes) that start with
		// find<beanName>
		List<Class> screenClasses = new ArrayList<Class>();
		ModelUtil.extractClasses(inCl.getModel(), Messages.screenStereotype, screenClasses);
		String refOpName = "find" + inCl.getName();
		for (Class curScr:screenClasses) {
			for (Object curOp_o:curScr.getOwnedOperations()) {
				Operation curOp = (Operation) curOp_o;
				if (curOp.getAppliedStereotype(Messages.useractionStereotype) != null && curOp.getName().startsWith(refOpName)) {
					c.add(curOp);
				}
			}
		}
		return c;
	}

}
