package com.ibm.jps.uxtoweb.frontend.custom;

import inputSchema.ScreenLink;

import org.eclipse.core.resources.IMarker;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.uml2.uml.AggregationKind;
import org.eclipse.uml2.uml.Class;
import org.eclipse.uml2.uml.Namespace;
import org.eclipse.uml2.uml.Operation;
import org.eclipse.uml2.uml.Stereotype;

import com.ibm.xtools.transform.authoring.RuleExtension;

public class Operation2ScreenLinkRule implements RuleExtension {

	public void execute(EObject arg0, EObject arg1) {
		ModelUtil.log("Operation2ScreenLinkRule", arg0);
		Operation inOp = (Operation) arg0;
		ScreenLink link = (ScreenLink) arg1;
		Namespace ns = inOp.getNamespace();
		if (ns  != null && ns instanceof Class) { // Should be a class in all cases
			Class cl = (Class) ns;
			Class tcl = ModelUtil.findAssocClass(cl, Messages.screenStereotype, AggregationKind.NONE_LITERAL, inOp.getName());
			if (tcl != null) {
				link.setToScreen(tcl.getName());
			}
		}
		// Label
		String label = "";
		Stereotype st = inOp.getAppliedStereotype(Messages.linkStereotype);
		if (st != null) { // should not be null
			if (inOp.getValue(st, Messages.labelProperty) != null) {
				label = (String) inOp.getValue(st, Messages.labelProperty);
			}
		}
		if (label.equals("")) label = ModelUtil.convertToTitle(inOp.getName());
		link.setLabel(label);
		// HandlerBean
		if (inOp.getName().startsWith("list")) {
			String beanName = ModelUtil.findMatchingBeanName(inOp);
			System.out.println(inOp.getName() + " > " + beanName);
			if (beanName.equals("")) {
                ModelUtil.addMarker(inOp, "No matching bean has been found for operation '" //$NON-NLS-1$
                        + inOp.getName() + "'. There will be no automatic code generation for this 'list' operation. Use a different word (like 'show') "
                        + "or indicate the bean to use, for instance by including its name in the operation (e.g. listCd) - see documentation for more information.", //$NON-NLS-1$
                        IMarker.SEVERITY_ERROR); 
				
			} else {
				link.setHandlerBean(beanName);
			}
		}
	}

}
